/*
WARNING! All changes made in this file will be lost!
Created from 'colors.palette' by 'codegen_style'

This file is part of Telegram Desktop,
the official desktop application for the Telegram messaging service.

For license and copyright information please follow this link:
https://github.com/telegramdesktop/tdesktop/blob/master/LEGAL
*/
#pragma once

#include "ui/style/style_core.h"

namespace style {
namespace internal {

void init_palette();

} // namespace internal

class palette {
public:
	palette() = default;
	palette(const palette &other) = delete;

	QByteArray save() const;
	bool load(const QByteArray &cache);

	enum class SetResult {
		Ok,
		KeyNotFound,
		ValueNotFound,
		Duplicate,
	};
	SetResult setColor(QLatin1String name, uchar r, uchar g, uchar b, uchar a);
	SetResult setColor(QLatin1String name, QLatin1String from);
	void reset() {
		clear();
		finalize();
	}

	// Created not inited, should be finalized before usage.
	void finalize();

	int indexOfColor(color c) const;
	color colorAtIndex(int index) const;

	inline const color &get_transparent() const { return _colors[0]; }; // special color
	inline const color &get_windowBg() const { return _colors[1]; };
	inline const color &get_windowFg() const { return _colors[2]; };
	inline const color &get_windowBgOver() const { return _colors[3]; };
	inline const color &get_windowBgRipple() const { return _colors[4]; };
	inline const color &get_windowFgOver() const { return _colors[5]; };
	inline const color &get_windowSubTextFg() const { return _colors[6]; };
	inline const color &get_windowSubTextFgOver() const { return _colors[7]; };
	inline const color &get_windowBoldFg() const { return _colors[8]; };
	inline const color &get_windowBoldFgOver() const { return _colors[9]; };
	inline const color &get_windowBgActive() const { return _colors[10]; };
	inline const color &get_windowFgActive() const { return _colors[11]; };
	inline const color &get_windowActiveTextFg() const { return _colors[12]; };
	inline const color &get_windowShadowFg() const { return _colors[13]; };
	inline const color &get_windowShadowFgFallback() const { return _colors[14]; };
	inline const color &get_shadowFg() const { return _colors[15]; };
	inline const color &get_slideFadeOutBg() const { return _colors[16]; };
	inline const color &get_slideFadeOutShadowFg() const { return _colors[17]; };
	inline const color &get_imageBg() const { return _colors[18]; };
	inline const color &get_imageBgTransparent() const { return _colors[19]; };
	inline const color &get_activeButtonBg() const { return _colors[20]; };
	inline const color &get_activeButtonBgOver() const { return _colors[21]; };
	inline const color &get_activeButtonBgRipple() const { return _colors[22]; };
	inline const color &get_activeButtonFg() const { return _colors[23]; };
	inline const color &get_activeButtonFgOver() const { return _colors[24]; };
	inline const color &get_activeButtonSecondaryFg() const { return _colors[25]; };
	inline const color &get_activeButtonSecondaryFgOver() const { return _colors[26]; };
	inline const color &get_activeLineFg() const { return _colors[27]; };
	inline const color &get_activeLineFgError() const { return _colors[28]; };
	inline const color &get_lightButtonBg() const { return _colors[29]; };
	inline const color &get_lightButtonBgOver() const { return _colors[30]; };
	inline const color &get_lightButtonBgRipple() const { return _colors[31]; };
	inline const color &get_lightButtonFg() const { return _colors[32]; };
	inline const color &get_lightButtonFgOver() const { return _colors[33]; };
	inline const color &get_attentionButtonFg() const { return _colors[34]; };
	inline const color &get_attentionButtonFgOver() const { return _colors[35]; };
	inline const color &get_attentionButtonBgOver() const { return _colors[36]; };
	inline const color &get_attentionButtonBgRipple() const { return _colors[37]; };
	inline const color &get_outlineButtonBg() const { return _colors[38]; };
	inline const color &get_outlineButtonBgOver() const { return _colors[39]; };
	inline const color &get_outlineButtonOutlineFg() const { return _colors[40]; };
	inline const color &get_outlineButtonBgRipple() const { return _colors[41]; };
	inline const color &get_menuBg() const { return _colors[42]; };
	inline const color &get_menuBgOver() const { return _colors[43]; };
	inline const color &get_menuBgRipple() const { return _colors[44]; };
	inline const color &get_menuIconFg() const { return _colors[45]; };
	inline const color &get_menuIconFgOver() const { return _colors[46]; };
	inline const color &get_menuSubmenuArrowFg() const { return _colors[47]; };
	inline const color &get_menuFgDisabled() const { return _colors[48]; };
	inline const color &get_menuSeparatorFg() const { return _colors[49]; };
	inline const color &get_scrollBarBg() const { return _colors[50]; };
	inline const color &get_scrollBarBgOver() const { return _colors[51]; };
	inline const color &get_scrollBg() const { return _colors[52]; };
	inline const color &get_scrollBgOver() const { return _colors[53]; };
	inline const color &get_smallCloseIconFg() const { return _colors[54]; };
	inline const color &get_smallCloseIconFgOver() const { return _colors[55]; };
	inline const color &get_radialFg() const { return _colors[56]; };
	inline const color &get_radialBg() const { return _colors[57]; };
	inline const color &get_placeholderFg() const { return _colors[58]; };
	inline const color &get_placeholderFgActive() const { return _colors[59]; };
	inline const color &get_inputBorderFg() const { return _colors[60]; };
	inline const color &get_filterInputBorderFg() const { return _colors[61]; };
	inline const color &get_filterInputActiveBg() const { return _colors[62]; };
	inline const color &get_filterInputInactiveBg() const { return _colors[63]; };
	inline const color &get_checkboxFg() const { return _colors[64]; };
	inline const color &get_botKbBg() const { return _colors[65]; };
	inline const color &get_botKbDownBg() const { return _colors[66]; };
	inline const color &get_botKbColor() const { return _colors[67]; };
	inline const color &get_sliderBgInactive() const { return _colors[68]; };
	inline const color &get_sliderBgActive() const { return _colors[69]; };
	inline const color &get_tooltipBg() const { return _colors[70]; };
	inline const color &get_tooltipFg() const { return _colors[71]; };
	inline const color &get_tooltipBorderFg() const { return _colors[72]; };
	inline const color &get_titleShadow() const { return _colors[73]; };
	inline const color &get_titleBg() const { return _colors[74]; };
	inline const color &get_titleBgActive() const { return _colors[75]; };
	inline const color &get_titleButtonBg() const { return _colors[76]; };
	inline const color &get_titleButtonFg() const { return _colors[77]; };
	inline const color &get_titleButtonBgOver() const { return _colors[78]; };
	inline const color &get_titleButtonFgOver() const { return _colors[79]; };
	inline const color &get_titleButtonBgActive() const { return _colors[80]; };
	inline const color &get_titleButtonFgActive() const { return _colors[81]; };
	inline const color &get_titleButtonBgActiveOver() const { return _colors[82]; };
	inline const color &get_titleButtonFgActiveOver() const { return _colors[83]; };
	inline const color &get_titleButtonCloseBg() const { return _colors[84]; };
	inline const color &get_titleButtonCloseFg() const { return _colors[85]; };
	inline const color &get_titleButtonCloseBgOver() const { return _colors[86]; };
	inline const color &get_titleButtonCloseFgOver() const { return _colors[87]; };
	inline const color &get_titleButtonCloseBgActive() const { return _colors[88]; };
	inline const color &get_titleButtonCloseFgActive() const { return _colors[89]; };
	inline const color &get_titleButtonCloseBgActiveOver() const { return _colors[90]; };
	inline const color &get_titleButtonCloseFgActiveOver() const { return _colors[91]; };
	inline const color &get_titleFg() const { return _colors[92]; };
	inline const color &get_titleFgActive() const { return _colors[93]; };
	inline const color &get_trayCounterBg() const { return _colors[94]; };
	inline const color &get_trayCounterBgMute() const { return _colors[95]; };
	inline const color &get_trayCounterFg() const { return _colors[96]; };
	inline const color &get_trayCounterBgMacInvert() const { return _colors[97]; };
	inline const color &get_trayCounterFgMacInvert() const { return _colors[98]; };
	inline const color &get_layerBg() const { return _colors[99]; };
	inline const color &get_cancelIconFg() const { return _colors[100]; };
	inline const color &get_cancelIconFgOver() const { return _colors[101]; };
	inline const color &get_boxBg() const { return _colors[102]; };
	inline const color &get_boxTextFg() const { return _colors[103]; };
	inline const color &get_boxTextFgGood() const { return _colors[104]; };
	inline const color &get_boxTextFgError() const { return _colors[105]; };
	inline const color &get_boxTitleFg() const { return _colors[106]; };
	inline const color &get_boxSearchBg() const { return _colors[107]; };
	inline const color &get_boxTitleAdditionalFg() const { return _colors[108]; };
	inline const color &get_boxTitleCloseFg() const { return _colors[109]; };
	inline const color &get_boxTitleCloseFgOver() const { return _colors[110]; };
	inline const color &get_membersAboutLimitFg() const { return _colors[111]; };
	inline const color &get_contactsBg() const { return _colors[112]; };
	inline const color &get_contactsBgOver() const { return _colors[113]; };
	inline const color &get_contactsNameFg() const { return _colors[114]; };
	inline const color &get_contactsStatusFg() const { return _colors[115]; };
	inline const color &get_contactsStatusFgOver() const { return _colors[116]; };
	inline const color &get_contactsStatusFgOnline() const { return _colors[117]; };
	inline const color &get_photoCropFadeBg() const { return _colors[118]; };
	inline const color &get_photoCropPointFg() const { return _colors[119]; };
	inline const color &get_callArrowFg() const { return _colors[120]; };
	inline const color &get_callArrowMissedFg() const { return _colors[121]; };
	inline const color &get_introBg() const { return _colors[122]; };
	inline const color &get_introTitleFg() const { return _colors[123]; };
	inline const color &get_introDescriptionFg() const { return _colors[124]; };
	inline const color &get_introErrorFg() const { return _colors[125]; };
	inline const color &get_introCoverTopBg() const { return _colors[126]; };
	inline const color &get_introCoverBottomBg() const { return _colors[127]; };
	inline const color &get_introCoverIconsFg() const { return _colors[128]; };
	inline const color &get_introCoverPlaneTrace() const { return _colors[129]; };
	inline const color &get_introCoverPlaneInner() const { return _colors[130]; };
	inline const color &get_introCoverPlaneOuter() const { return _colors[131]; };
	inline const color &get_introCoverPlaneTop() const { return _colors[132]; };
	inline const color &get_dialogsMenuIconFg() const { return _colors[133]; };
	inline const color &get_dialogsMenuIconFgOver() const { return _colors[134]; };
	inline const color &get_dialogsBg() const { return _colors[135]; };
	inline const color &get_dialogsNameFg() const { return _colors[136]; };
	inline const color &get_dialogsChatIconFg() const { return _colors[137]; };
	inline const color &get_dialogsDateFg() const { return _colors[138]; };
	inline const color &get_dialogsTextFg() const { return _colors[139]; };
	inline const color &get_dialogsTextFgService() const { return _colors[140]; };
	inline const color &get_dialogsDraftFg() const { return _colors[141]; };
	inline const color &get_dialogsVerifiedIconBg() const { return _colors[142]; };
	inline const color &get_dialogsVerifiedIconFg() const { return _colors[143]; };
	inline const color &get_dialogsSendingIconFg() const { return _colors[144]; };
	inline const color &get_dialogsSentIconFg() const { return _colors[145]; };
	inline const color &get_dialogsUnreadBg() const { return _colors[146]; };
	inline const color &get_dialogsUnreadBgMuted() const { return _colors[147]; };
	inline const color &get_dialogsUnreadFg() const { return _colors[148]; };
	inline const color &get_dialogsBgOver() const { return _colors[149]; };
	inline const color &get_dialogsNameFgOver() const { return _colors[150]; };
	inline const color &get_dialogsChatIconFgOver() const { return _colors[151]; };
	inline const color &get_dialogsDateFgOver() const { return _colors[152]; };
	inline const color &get_dialogsTextFgOver() const { return _colors[153]; };
	inline const color &get_dialogsTextFgServiceOver() const { return _colors[154]; };
	inline const color &get_dialogsDraftFgOver() const { return _colors[155]; };
	inline const color &get_dialogsVerifiedIconBgOver() const { return _colors[156]; };
	inline const color &get_dialogsVerifiedIconFgOver() const { return _colors[157]; };
	inline const color &get_dialogsSendingIconFgOver() const { return _colors[158]; };
	inline const color &get_dialogsSentIconFgOver() const { return _colors[159]; };
	inline const color &get_dialogsUnreadBgOver() const { return _colors[160]; };
	inline const color &get_dialogsUnreadBgMutedOver() const { return _colors[161]; };
	inline const color &get_dialogsUnreadFgOver() const { return _colors[162]; };
	inline const color &get_dialogsBgActive() const { return _colors[163]; };
	inline const color &get_dialogsNameFgActive() const { return _colors[164]; };
	inline const color &get_dialogsChatIconFgActive() const { return _colors[165]; };
	inline const color &get_dialogsDateFgActive() const { return _colors[166]; };
	inline const color &get_dialogsTextFgActive() const { return _colors[167]; };
	inline const color &get_dialogsTextFgServiceActive() const { return _colors[168]; };
	inline const color &get_dialogsDraftFgActive() const { return _colors[169]; };
	inline const color &get_dialogsVerifiedIconBgActive() const { return _colors[170]; };
	inline const color &get_dialogsVerifiedIconFgActive() const { return _colors[171]; };
	inline const color &get_dialogsSendingIconFgActive() const { return _colors[172]; };
	inline const color &get_dialogsSentIconFgActive() const { return _colors[173]; };
	inline const color &get_dialogsUnreadBgActive() const { return _colors[174]; };
	inline const color &get_dialogsUnreadBgMutedActive() const { return _colors[175]; };
	inline const color &get_dialogsUnreadFgActive() const { return _colors[176]; };
	inline const color &get_dialogsRippleBg() const { return _colors[177]; };
	inline const color &get_dialogsRippleBgActive() const { return _colors[178]; };
	inline const color &get_dialogsForwardBg() const { return _colors[179]; };
	inline const color &get_dialogsForwardFg() const { return _colors[180]; };
	inline const color &get_searchedBarBg() const { return _colors[181]; };
	inline const color &get_searchedBarFg() const { return _colors[182]; };
	inline const color &get_topBarBg() const { return _colors[183]; };
	inline const color &get_emojiPanBg() const { return _colors[184]; };
	inline const color &get_emojiPanCategories() const { return _colors[185]; };
	inline const color &get_emojiPanHeaderFg() const { return _colors[186]; };
	inline const color &get_emojiPanHeaderBg() const { return _colors[187]; };
	inline const color &get_emojiIconFg() const { return _colors[188]; };
	inline const color &get_emojiIconFgActive() const { return _colors[189]; };
	inline const color &get_stickerPanDeleteBg() const { return _colors[190]; };
	inline const color &get_stickerPanDeleteFg() const { return _colors[191]; };
	inline const color &get_stickerPreviewBg() const { return _colors[192]; };
	inline const color &get_historyTextInFg() const { return _colors[193]; };
	inline const color &get_historyTextInFgSelected() const { return _colors[194]; };
	inline const color &get_historyTextOutFg() const { return _colors[195]; };
	inline const color &get_historyTextOutFgSelected() const { return _colors[196]; };
	inline const color &get_historyLinkInFg() const { return _colors[197]; };
	inline const color &get_historyLinkInFgSelected() const { return _colors[198]; };
	inline const color &get_historyLinkOutFg() const { return _colors[199]; };
	inline const color &get_historyLinkOutFgSelected() const { return _colors[200]; };
	inline const color &get_historyFileNameInFg() const { return _colors[201]; };
	inline const color &get_historyFileNameInFgSelected() const { return _colors[202]; };
	inline const color &get_historyFileNameOutFg() const { return _colors[203]; };
	inline const color &get_historyFileNameOutFgSelected() const { return _colors[204]; };
	inline const color &get_historyOutIconFg() const { return _colors[205]; };
	inline const color &get_historyOutIconFgSelected() const { return _colors[206]; };
	inline const color &get_historyIconFgInverted() const { return _colors[207]; };
	inline const color &get_historySendingOutIconFg() const { return _colors[208]; };
	inline const color &get_historySendingInIconFg() const { return _colors[209]; };
	inline const color &get_historySendingInvertedIconFg() const { return _colors[210]; };
	inline const color &get_historyCallArrowInFg() const { return _colors[211]; };
	inline const color &get_historyCallArrowInFgSelected() const { return _colors[212]; };
	inline const color &get_historyCallArrowMissedInFg() const { return _colors[213]; };
	inline const color &get_historyCallArrowMissedInFgSelected() const { return _colors[214]; };
	inline const color &get_historyCallArrowOutFg() const { return _colors[215]; };
	inline const color &get_historyCallArrowOutFgSelected() const { return _colors[216]; };
	inline const color &get_historyUnreadBarBg() const { return _colors[217]; };
	inline const color &get_historyUnreadBarBorder() const { return _colors[218]; };
	inline const color &get_historyUnreadBarFg() const { return _colors[219]; };
	inline const color &get_historyForwardChooseBg() const { return _colors[220]; };
	inline const color &get_historyForwardChooseFg() const { return _colors[221]; };
	inline const color &get_historyPeer1NameFg() const { return _colors[222]; };
	inline const color &get_historyPeer1NameFgSelected() const { return _colors[223]; };
	inline const color &get_historyPeer1UserpicBg() const { return _colors[224]; };
	inline const color &get_historyPeer2NameFg() const { return _colors[225]; };
	inline const color &get_historyPeer2NameFgSelected() const { return _colors[226]; };
	inline const color &get_historyPeer2UserpicBg() const { return _colors[227]; };
	inline const color &get_historyPeer3NameFg() const { return _colors[228]; };
	inline const color &get_historyPeer3NameFgSelected() const { return _colors[229]; };
	inline const color &get_historyPeer3UserpicBg() const { return _colors[230]; };
	inline const color &get_historyPeer4NameFg() const { return _colors[231]; };
	inline const color &get_historyPeer4NameFgSelected() const { return _colors[232]; };
	inline const color &get_historyPeer4UserpicBg() const { return _colors[233]; };
	inline const color &get_historyPeer5NameFg() const { return _colors[234]; };
	inline const color &get_historyPeer5NameFgSelected() const { return _colors[235]; };
	inline const color &get_historyPeer5UserpicBg() const { return _colors[236]; };
	inline const color &get_historyPeer6NameFg() const { return _colors[237]; };
	inline const color &get_historyPeer6NameFgSelected() const { return _colors[238]; };
	inline const color &get_historyPeer6UserpicBg() const { return _colors[239]; };
	inline const color &get_historyPeer7NameFg() const { return _colors[240]; };
	inline const color &get_historyPeer7NameFgSelected() const { return _colors[241]; };
	inline const color &get_historyPeer7UserpicBg() const { return _colors[242]; };
	inline const color &get_historyPeer8NameFg() const { return _colors[243]; };
	inline const color &get_historyPeer8NameFgSelected() const { return _colors[244]; };
	inline const color &get_historyPeer8UserpicBg() const { return _colors[245]; };
	inline const color &get_historyPeerUserpicFg() const { return _colors[246]; };
	inline const color &get_historyPeerSavedMessagesBg() const { return _colors[247]; };
	inline const color &get_historyScrollBarBg() const { return _colors[248]; };
	inline const color &get_historyScrollBarBgOver() const { return _colors[249]; };
	inline const color &get_historyScrollBg() const { return _colors[250]; };
	inline const color &get_historyScrollBgOver() const { return _colors[251]; };
	inline const color &get_msgInBg() const { return _colors[252]; };
	inline const color &get_msgInBgSelected() const { return _colors[253]; };
	inline const color &get_msgOutBg() const { return _colors[254]; };
	inline const color &get_msgOutBgSelected() const { return _colors[255]; };
	inline const color &get_msgSelectOverlay() const { return _colors[256]; };
	inline const color &get_msgStickerOverlay() const { return _colors[257]; };
	inline const color &get_msgInServiceFg() const { return _colors[258]; };
	inline const color &get_msgInServiceFgSelected() const { return _colors[259]; };
	inline const color &get_msgOutServiceFg() const { return _colors[260]; };
	inline const color &get_msgOutServiceFgSelected() const { return _colors[261]; };
	inline const color &get_msgInShadow() const { return _colors[262]; };
	inline const color &get_msgInShadowSelected() const { return _colors[263]; };
	inline const color &get_msgOutShadow() const { return _colors[264]; };
	inline const color &get_msgOutShadowSelected() const { return _colors[265]; };
	inline const color &get_msgInDateFg() const { return _colors[266]; };
	inline const color &get_msgInDateFgSelected() const { return _colors[267]; };
	inline const color &get_msgOutDateFg() const { return _colors[268]; };
	inline const color &get_msgOutDateFgSelected() const { return _colors[269]; };
	inline const color &get_msgServiceFg() const { return _colors[270]; };
	inline const color &get_msgServiceBg() const { return _colors[271]; };
	inline const color &get_msgServiceBgSelected() const { return _colors[272]; };
	inline const color &get_msgInReplyBarColor() const { return _colors[273]; };
	inline const color &get_msgInReplyBarSelColor() const { return _colors[274]; };
	inline const color &get_msgOutReplyBarColor() const { return _colors[275]; };
	inline const color &get_msgOutReplyBarSelColor() const { return _colors[276]; };
	inline const color &get_msgImgReplyBarColor() const { return _colors[277]; };
	inline const color &get_msgInMonoFg() const { return _colors[278]; };
	inline const color &get_msgOutMonoFg() const { return _colors[279]; };
	inline const color &get_msgInMonoFgSelected() const { return _colors[280]; };
	inline const color &get_msgOutMonoFgSelected() const { return _colors[281]; };
	inline const color &get_msgDateImgFg() const { return _colors[282]; };
	inline const color &get_msgDateImgBg() const { return _colors[283]; };
	inline const color &get_msgDateImgBgOver() const { return _colors[284]; };
	inline const color &get_msgDateImgBgSelected() const { return _colors[285]; };
	inline const color &get_msgFileThumbLinkInFg() const { return _colors[286]; };
	inline const color &get_msgFileThumbLinkInFgSelected() const { return _colors[287]; };
	inline const color &get_msgFileThumbLinkOutFg() const { return _colors[288]; };
	inline const color &get_msgFileThumbLinkOutFgSelected() const { return _colors[289]; };
	inline const color &get_msgFileInBg() const { return _colors[290]; };
	inline const color &get_msgFileInBgOver() const { return _colors[291]; };
	inline const color &get_msgFileInBgSelected() const { return _colors[292]; };
	inline const color &get_msgFileOutBg() const { return _colors[293]; };
	inline const color &get_msgFileOutBgOver() const { return _colors[294]; };
	inline const color &get_msgFileOutBgSelected() const { return _colors[295]; };
	inline const color &get_msgFile1Bg() const { return _colors[296]; };
	inline const color &get_msgFile1BgDark() const { return _colors[297]; };
	inline const color &get_msgFile1BgOver() const { return _colors[298]; };
	inline const color &get_msgFile1BgSelected() const { return _colors[299]; };
	inline const color &get_msgFile2Bg() const { return _colors[300]; };
	inline const color &get_msgFile2BgDark() const { return _colors[301]; };
	inline const color &get_msgFile2BgOver() const { return _colors[302]; };
	inline const color &get_msgFile2BgSelected() const { return _colors[303]; };
	inline const color &get_msgFile3Bg() const { return _colors[304]; };
	inline const color &get_msgFile3BgDark() const { return _colors[305]; };
	inline const color &get_msgFile3BgOver() const { return _colors[306]; };
	inline const color &get_msgFile3BgSelected() const { return _colors[307]; };
	inline const color &get_msgFile4Bg() const { return _colors[308]; };
	inline const color &get_msgFile4BgDark() const { return _colors[309]; };
	inline const color &get_msgFile4BgOver() const { return _colors[310]; };
	inline const color &get_msgFile4BgSelected() const { return _colors[311]; };
	inline const color &get_historyFileInIconFg() const { return _colors[312]; };
	inline const color &get_historyFileInIconFgSelected() const { return _colors[313]; };
	inline const color &get_historyFileInRadialFg() const { return _colors[314]; };
	inline const color &get_historyFileInRadialFgSelected() const { return _colors[315]; };
	inline const color &get_historyFileOutIconFg() const { return _colors[316]; };
	inline const color &get_historyFileOutIconFgSelected() const { return _colors[317]; };
	inline const color &get_historyFileOutRadialFg() const { return _colors[318]; };
	inline const color &get_historyFileOutRadialFgSelected() const { return _colors[319]; };
	inline const color &get_historyFileThumbIconFg() const { return _colors[320]; };
	inline const color &get_historyFileThumbIconFgSelected() const { return _colors[321]; };
	inline const color &get_historyFileThumbRadialFg() const { return _colors[322]; };
	inline const color &get_historyFileThumbRadialFgSelected() const { return _colors[323]; };
	inline const color &get_historyVideoMessageProgressFg() const { return _colors[324]; };
	inline const color &get_msgWaveformInActive() const { return _colors[325]; };
	inline const color &get_msgWaveformInActiveSelected() const { return _colors[326]; };
	inline const color &get_msgWaveformInInactive() const { return _colors[327]; };
	inline const color &get_msgWaveformInInactiveSelected() const { return _colors[328]; };
	inline const color &get_msgWaveformOutActive() const { return _colors[329]; };
	inline const color &get_msgWaveformOutActiveSelected() const { return _colors[330]; };
	inline const color &get_msgWaveformOutInactive() const { return _colors[331]; };
	inline const color &get_msgWaveformOutInactiveSelected() const { return _colors[332]; };
	inline const color &get_msgBotKbOverBgAdd() const { return _colors[333]; };
	inline const color &get_msgBotKbIconFg() const { return _colors[334]; };
	inline const color &get_msgBotKbRippleBg() const { return _colors[335]; };
	inline const color &get_mediaInFg() const { return _colors[336]; };
	inline const color &get_mediaInFgSelected() const { return _colors[337]; };
	inline const color &get_mediaOutFg() const { return _colors[338]; };
	inline const color &get_mediaOutFgSelected() const { return _colors[339]; };
	inline const color &get_youtubePlayIconBg() const { return _colors[340]; };
	inline const color &get_youtubePlayIconFg() const { return _colors[341]; };
	inline const color &get_videoPlayIconBg() const { return _colors[342]; };
	inline const color &get_videoPlayIconFg() const { return _colors[343]; };
	inline const color &get_toastBg() const { return _colors[344]; };
	inline const color &get_toastFg() const { return _colors[345]; };
	inline const color &get_reportSpamBg() const { return _colors[346]; };
	inline const color &get_reportSpamFg() const { return _colors[347]; };
	inline const color &get_historyToDownBg() const { return _colors[348]; };
	inline const color &get_historyToDownBgOver() const { return _colors[349]; };
	inline const color &get_historyToDownBgRipple() const { return _colors[350]; };
	inline const color &get_historyToDownFg() const { return _colors[351]; };
	inline const color &get_historyToDownFgOver() const { return _colors[352]; };
	inline const color &get_historyToDownShadow() const { return _colors[353]; };
	inline const color &get_historyComposeAreaBg() const { return _colors[354]; };
	inline const color &get_historyComposeAreaFg() const { return _colors[355]; };
	inline const color &get_historyComposeAreaFgService() const { return _colors[356]; };
	inline const color &get_historyComposeIconFg() const { return _colors[357]; };
	inline const color &get_historyComposeIconFgOver() const { return _colors[358]; };
	inline const color &get_historySendIconFg() const { return _colors[359]; };
	inline const color &get_historySendIconFgOver() const { return _colors[360]; };
	inline const color &get_historyPinnedBg() const { return _colors[361]; };
	inline const color &get_historyReplyBg() const { return _colors[362]; };
	inline const color &get_historyReplyIconFg() const { return _colors[363]; };
	inline const color &get_historyReplyCancelFg() const { return _colors[364]; };
	inline const color &get_historyReplyCancelFgOver() const { return _colors[365]; };
	inline const color &get_historyComposeButtonBg() const { return _colors[366]; };
	inline const color &get_historyComposeButtonBgOver() const { return _colors[367]; };
	inline const color &get_historyComposeButtonBgRipple() const { return _colors[368]; };
	inline const color &get_mapPointDrop() const { return _colors[369]; };
	inline const color &get_mapPointDot() const { return _colors[370]; };
	inline const color &get_overviewCheckBg() const { return _colors[371]; };
	inline const color &get_overviewCheckBgActive() const { return _colors[372]; };
	inline const color &get_overviewCheckBorder() const { return _colors[373]; };
	inline const color &get_overviewCheckFg() const { return _colors[374]; };
	inline const color &get_overviewCheckFgActive() const { return _colors[375]; };
	inline const color &get_overviewPhotoSelectOverlay() const { return _colors[376]; };
	inline const color &get_profileStatusFgOver() const { return _colors[377]; };
	inline const color &get_profileVerifiedCheckBg() const { return _colors[378]; };
	inline const color &get_profileVerifiedCheckFg() const { return _colors[379]; };
	inline const color &get_profileAdminStartFg() const { return _colors[380]; };
	inline const color &get_profileAdminStarFgOver() const { return _colors[381]; };
	inline const color &get_profileOtherAdminStarFg() const { return _colors[382]; };
	inline const color &get_profileOtherAdminStarFgOver() const { return _colors[383]; };
	inline const color &get_notificationsBoxMonitorFg() const { return _colors[384]; };
	inline const color &get_notificationsBoxScreenBg() const { return _colors[385]; };
	inline const color &get_notificationSampleUserpicFg() const { return _colors[386]; };
	inline const color &get_notificationSampleCloseFg() const { return _colors[387]; };
	inline const color &get_notificationSampleTextFg() const { return _colors[388]; };
	inline const color &get_notificationSampleNameFg() const { return _colors[389]; };
	inline const color &get_changePhoneSimcardFrom() const { return _colors[390]; };
	inline const color &get_changePhoneSimcardTo() const { return _colors[391]; };
	inline const color &get_mainMenuBg() const { return _colors[392]; };
	inline const color &get_mainMenuCoverBg() const { return _colors[393]; };
	inline const color &get_mainMenuCoverFg() const { return _colors[394]; };
	inline const color &get_mainMenuCloudFg() const { return _colors[395]; };
	inline const color &get_mainMenuCloudBg() const { return _colors[396]; };
	inline const color &get_mediaPlayerBg() const { return _colors[397]; };
	inline const color &get_mediaPlayerActiveFg() const { return _colors[398]; };
	inline const color &get_mediaPlayerInactiveFg() const { return _colors[399]; };
	inline const color &get_mediaPlayerDisabledFg() const { return _colors[400]; };
	inline const color &get_mediaviewFileBg() const { return _colors[401]; };
	inline const color &get_mediaviewFileNameFg() const { return _colors[402]; };
	inline const color &get_mediaviewFileSizeFg() const { return _colors[403]; };
	inline const color &get_mediaviewFileRedCornerFg() const { return _colors[404]; };
	inline const color &get_mediaviewFileYellowCornerFg() const { return _colors[405]; };
	inline const color &get_mediaviewFileGreenCornerFg() const { return _colors[406]; };
	inline const color &get_mediaviewFileBlueCornerFg() const { return _colors[407]; };
	inline const color &get_mediaviewFileExtFg() const { return _colors[408]; };
	inline const color &get_mediaviewMenuBg() const { return _colors[409]; };
	inline const color &get_mediaviewMenuBgOver() const { return _colors[410]; };
	inline const color &get_mediaviewMenuBgRipple() const { return _colors[411]; };
	inline const color &get_mediaviewMenuFg() const { return _colors[412]; };
	inline const color &get_mediaviewBg() const { return _colors[413]; };
	inline const color &get_mediaviewVideoBg() const { return _colors[414]; };
	inline const color &get_mediaviewControlBg() const { return _colors[415]; };
	inline const color &get_mediaviewControlFg() const { return _colors[416]; };
	inline const color &get_mediaviewCaptionBg() const { return _colors[417]; };
	inline const color &get_mediaviewCaptionFg() const { return _colors[418]; };
	inline const color &get_mediaviewTextLinkFg() const { return _colors[419]; };
	inline const color &get_mediaviewSaveMsgBg() const { return _colors[420]; };
	inline const color &get_mediaviewSaveMsgFg() const { return _colors[421]; };
	inline const color &get_mediaviewPlaybackActive() const { return _colors[422]; };
	inline const color &get_mediaviewPlaybackInactive() const { return _colors[423]; };
	inline const color &get_mediaviewPlaybackActiveOver() const { return _colors[424]; };
	inline const color &get_mediaviewPlaybackInactiveOver() const { return _colors[425]; };
	inline const color &get_mediaviewPlaybackProgressFg() const { return _colors[426]; };
	inline const color &get_mediaviewPlaybackIconFg() const { return _colors[427]; };
	inline const color &get_mediaviewPlaybackIconFgOver() const { return _colors[428]; };
	inline const color &get_mediaviewTransparentBg() const { return _colors[429]; };
	inline const color &get_mediaviewTransparentFg() const { return _colors[430]; };
	inline const color &get_notificationBg() const { return _colors[431]; };
	inline const color &get_callBg() const { return _colors[432]; };
	inline const color &get_callNameFg() const { return _colors[433]; };
	inline const color &get_callFingerprintBg() const { return _colors[434]; };
	inline const color &get_callStatusFg() const { return _colors[435]; };
	inline const color &get_callIconFg() const { return _colors[436]; };
	inline const color &get_callAnswerBg() const { return _colors[437]; };
	inline const color &get_callAnswerRipple() const { return _colors[438]; };
	inline const color &get_callAnswerBgOuter() const { return _colors[439]; };
	inline const color &get_callHangupBg() const { return _colors[440]; };
	inline const color &get_callHangupRipple() const { return _colors[441]; };
	inline const color &get_callCancelBg() const { return _colors[442]; };
	inline const color &get_callCancelFg() const { return _colors[443]; };
	inline const color &get_callCancelRipple() const { return _colors[444]; };
	inline const color &get_callMuteRipple() const { return _colors[445]; };
	inline const color &get_callBarBg() const { return _colors[446]; };
	inline const color &get_callBarMuteRipple() const { return _colors[447]; };
	inline const color &get_callBarBgMuted() const { return _colors[448]; };
	inline const color &get_callBarUnmuteRipple() const { return _colors[449]; };
	inline const color &get_callBarFg() const { return _colors[450]; };
	inline const color &get_importantTooltipBg() const { return _colors[451]; };
	inline const color &get_importantTooltipFg() const { return _colors[452]; };
	inline const color &get_importantTooltipFgLink() const { return _colors[453]; };

	palette &operator=(const palette &other) {
		auto wasReady = _ready;
		for (int i = 0; i != kCount; ++i) {
			if (other._status[i] == Status::Loaded) {
				if (_status[i] == Status::Initial) {
					new (data(i)) internal::ColorData(*other.data(i));
				} else {
					*data(i) = *other.data(i);
				}
			} else if (_status[i] != Status::Initial) {
				data(i)->~ColorData();
				_status[i] = Status::Initial;
				_ready = false;
			}
		}
		if (wasReady && !_ready) {
			finalize();
		}
		return *this;
	}

	static int32 Checksum();

	~palette() {
		clear();
	}

private:
	static constexpr auto kCount = 454;

	void clear() {
		for (int i = 0; i != kCount; ++i) {
			if (_status[i] != Status::Initial) {
				data(i)->~ColorData();
				_status[i] = Status::Initial;
				_ready = false;
			}
		}
	}

	struct TempColorData { uchar r, g, b, a; };
	void compute(int index, int fallbackIndex, TempColorData value) {
		if (_status[index] == Status::Initial) {
			if (fallbackIndex >= 0 && _status[fallbackIndex] == Status::Loaded) {
				_status[index] = Status::Loaded;
				new (data(index)) internal::ColorData(*data(fallbackIndex));
			} else {
				_status[index] = Status::Created;
				new (data(index)) internal::ColorData(value.r, value.g, value.b, value.a);
			}
		}
	}

	internal::ColorData *data(int index) {
		return reinterpret_cast<internal::ColorData*>(_data) + index;
	}

	const internal::ColorData *data(int index) const {
		return reinterpret_cast<const internal::ColorData*>(_data) + index;
	}

	void setData(int index, const internal::ColorData &value) {
		if (_status[index] == Status::Initial) {
			new (data(index)) internal::ColorData(value);
		} else {
			*data(index) = value;
		}
		_status[index] = Status::Loaded;
	}

	enum class Status {
		Initial,
		Created,
		Loaded,
	};

	alignas(alignof(internal::ColorData)) char _data[sizeof(internal::ColorData) * kCount];

	color _colors[kCount] = {
		data(0),
		data(1),
		data(2),
		data(3),
		data(4),
		data(5),
		data(6),
		data(7),
		data(8),
		data(9),
		data(10),
		data(11),
		data(12),
		data(13),
		data(14),
		data(15),
		data(16),
		data(17),
		data(18),
		data(19),
		data(20),
		data(21),
		data(22),
		data(23),
		data(24),
		data(25),
		data(26),
		data(27),
		data(28),
		data(29),
		data(30),
		data(31),
		data(32),
		data(33),
		data(34),
		data(35),
		data(36),
		data(37),
		data(38),
		data(39),
		data(40),
		data(41),
		data(42),
		data(43),
		data(44),
		data(45),
		data(46),
		data(47),
		data(48),
		data(49),
		data(50),
		data(51),
		data(52),
		data(53),
		data(54),
		data(55),
		data(56),
		data(57),
		data(58),
		data(59),
		data(60),
		data(61),
		data(62),
		data(63),
		data(64),
		data(65),
		data(66),
		data(67),
		data(68),
		data(69),
		data(70),
		data(71),
		data(72),
		data(73),
		data(74),
		data(75),
		data(76),
		data(77),
		data(78),
		data(79),
		data(80),
		data(81),
		data(82),
		data(83),
		data(84),
		data(85),
		data(86),
		data(87),
		data(88),
		data(89),
		data(90),
		data(91),
		data(92),
		data(93),
		data(94),
		data(95),
		data(96),
		data(97),
		data(98),
		data(99),
		data(100),
		data(101),
		data(102),
		data(103),
		data(104),
		data(105),
		data(106),
		data(107),
		data(108),
		data(109),
		data(110),
		data(111),
		data(112),
		data(113),
		data(114),
		data(115),
		data(116),
		data(117),
		data(118),
		data(119),
		data(120),
		data(121),
		data(122),
		data(123),
		data(124),
		data(125),
		data(126),
		data(127),
		data(128),
		data(129),
		data(130),
		data(131),
		data(132),
		data(133),
		data(134),
		data(135),
		data(136),
		data(137),
		data(138),
		data(139),
		data(140),
		data(141),
		data(142),
		data(143),
		data(144),
		data(145),
		data(146),
		data(147),
		data(148),
		data(149),
		data(150),
		data(151),
		data(152),
		data(153),
		data(154),
		data(155),
		data(156),
		data(157),
		data(158),
		data(159),
		data(160),
		data(161),
		data(162),
		data(163),
		data(164),
		data(165),
		data(166),
		data(167),
		data(168),
		data(169),
		data(170),
		data(171),
		data(172),
		data(173),
		data(174),
		data(175),
		data(176),
		data(177),
		data(178),
		data(179),
		data(180),
		data(181),
		data(182),
		data(183),
		data(184),
		data(185),
		data(186),
		data(187),
		data(188),
		data(189),
		data(190),
		data(191),
		data(192),
		data(193),
		data(194),
		data(195),
		data(196),
		data(197),
		data(198),
		data(199),
		data(200),
		data(201),
		data(202),
		data(203),
		data(204),
		data(205),
		data(206),
		data(207),
		data(208),
		data(209),
		data(210),
		data(211),
		data(212),
		data(213),
		data(214),
		data(215),
		data(216),
		data(217),
		data(218),
		data(219),
		data(220),
		data(221),
		data(222),
		data(223),
		data(224),
		data(225),
		data(226),
		data(227),
		data(228),
		data(229),
		data(230),
		data(231),
		data(232),
		data(233),
		data(234),
		data(235),
		data(236),
		data(237),
		data(238),
		data(239),
		data(240),
		data(241),
		data(242),
		data(243),
		data(244),
		data(245),
		data(246),
		data(247),
		data(248),
		data(249),
		data(250),
		data(251),
		data(252),
		data(253),
		data(254),
		data(255),
		data(256),
		data(257),
		data(258),
		data(259),
		data(260),
		data(261),
		data(262),
		data(263),
		data(264),
		data(265),
		data(266),
		data(267),
		data(268),
		data(269),
		data(270),
		data(271),
		data(272),
		data(273),
		data(274),
		data(275),
		data(276),
		data(277),
		data(278),
		data(279),
		data(280),
		data(281),
		data(282),
		data(283),
		data(284),
		data(285),
		data(286),
		data(287),
		data(288),
		data(289),
		data(290),
		data(291),
		data(292),
		data(293),
		data(294),
		data(295),
		data(296),
		data(297),
		data(298),
		data(299),
		data(300),
		data(301),
		data(302),
		data(303),
		data(304),
		data(305),
		data(306),
		data(307),
		data(308),
		data(309),
		data(310),
		data(311),
		data(312),
		data(313),
		data(314),
		data(315),
		data(316),
		data(317),
		data(318),
		data(319),
		data(320),
		data(321),
		data(322),
		data(323),
		data(324),
		data(325),
		data(326),
		data(327),
		data(328),
		data(329),
		data(330),
		data(331),
		data(332),
		data(333),
		data(334),
		data(335),
		data(336),
		data(337),
		data(338),
		data(339),
		data(340),
		data(341),
		data(342),
		data(343),
		data(344),
		data(345),
		data(346),
		data(347),
		data(348),
		data(349),
		data(350),
		data(351),
		data(352),
		data(353),
		data(354),
		data(355),
		data(356),
		data(357),
		data(358),
		data(359),
		data(360),
		data(361),
		data(362),
		data(363),
		data(364),
		data(365),
		data(366),
		data(367),
		data(368),
		data(369),
		data(370),
		data(371),
		data(372),
		data(373),
		data(374),
		data(375),
		data(376),
		data(377),
		data(378),
		data(379),
		data(380),
		data(381),
		data(382),
		data(383),
		data(384),
		data(385),
		data(386),
		data(387),
		data(388),
		data(389),
		data(390),
		data(391),
		data(392),
		data(393),
		data(394),
		data(395),
		data(396),
		data(397),
		data(398),
		data(399),
		data(400),
		data(401),
		data(402),
		data(403),
		data(404),
		data(405),
		data(406),
		data(407),
		data(408),
		data(409),
		data(410),
		data(411),
		data(412),
		data(413),
		data(414),
		data(415),
		data(416),
		data(417),
		data(418),
		data(419),
		data(420),
		data(421),
		data(422),
		data(423),
		data(424),
		data(425),
		data(426),
		data(427),
		data(428),
		data(429),
		data(430),
		data(431),
		data(432),
		data(433),
		data(434),
		data(435),
		data(436),
		data(437),
		data(438),
		data(439),
		data(440),
		data(441),
		data(442),
		data(443),
		data(444),
		data(445),
		data(446),
		data(447),
		data(448),
		data(449),
		data(450),
		data(451),
		data(452),
		data(453),
	};
	Status _status[kCount] = { Status::Initial };
	bool _ready = false;

};

namespace main_palette {

QByteArray save();
bool load(const QByteArray &cache);
palette::SetResult setColor(QLatin1String name, uchar r, uchar g, uchar b, uchar a);
palette::SetResult setColor(QLatin1String name, QLatin1String from);
void apply(const palette &other);
void reset();
int indexOfColor(color c);

struct row {
	QLatin1String name;
	QLatin1String value;
	QLatin1String fallback;
	QLatin1String description;
};
QList<row> data();

} // namespace main_palette
} // namespace style

namespace st {
extern const style::color &transparent; // special color
extern const style::color &windowBg;
extern const style::color &windowFg;
extern const style::color &windowBgOver;
extern const style::color &windowBgRipple;
extern const style::color &windowFgOver;
extern const style::color &windowSubTextFg;
extern const style::color &windowSubTextFgOver;
extern const style::color &windowBoldFg;
extern const style::color &windowBoldFgOver;
extern const style::color &windowBgActive;
extern const style::color &windowFgActive;
extern const style::color &windowActiveTextFg;
extern const style::color &windowShadowFg;
extern const style::color &windowShadowFgFallback;
extern const style::color &shadowFg;
extern const style::color &slideFadeOutBg;
extern const style::color &slideFadeOutShadowFg;
extern const style::color &imageBg;
extern const style::color &imageBgTransparent;
extern const style::color &activeButtonBg;
extern const style::color &activeButtonBgOver;
extern const style::color &activeButtonBgRipple;
extern const style::color &activeButtonFg;
extern const style::color &activeButtonFgOver;
extern const style::color &activeButtonSecondaryFg;
extern const style::color &activeButtonSecondaryFgOver;
extern const style::color &activeLineFg;
extern const style::color &activeLineFgError;
extern const style::color &lightButtonBg;
extern const style::color &lightButtonBgOver;
extern const style::color &lightButtonBgRipple;
extern const style::color &lightButtonFg;
extern const style::color &lightButtonFgOver;
extern const style::color &attentionButtonFg;
extern const style::color &attentionButtonFgOver;
extern const style::color &attentionButtonBgOver;
extern const style::color &attentionButtonBgRipple;
extern const style::color &outlineButtonBg;
extern const style::color &outlineButtonBgOver;
extern const style::color &outlineButtonOutlineFg;
extern const style::color &outlineButtonBgRipple;
extern const style::color &menuBg;
extern const style::color &menuBgOver;
extern const style::color &menuBgRipple;
extern const style::color &menuIconFg;
extern const style::color &menuIconFgOver;
extern const style::color &menuSubmenuArrowFg;
extern const style::color &menuFgDisabled;
extern const style::color &menuSeparatorFg;
extern const style::color &scrollBarBg;
extern const style::color &scrollBarBgOver;
extern const style::color &scrollBg;
extern const style::color &scrollBgOver;
extern const style::color &smallCloseIconFg;
extern const style::color &smallCloseIconFgOver;
extern const style::color &radialFg;
extern const style::color &radialBg;
extern const style::color &placeholderFg;
extern const style::color &placeholderFgActive;
extern const style::color &inputBorderFg;
extern const style::color &filterInputBorderFg;
extern const style::color &filterInputActiveBg;
extern const style::color &filterInputInactiveBg;
extern const style::color &checkboxFg;
extern const style::color &botKbBg;
extern const style::color &botKbDownBg;
extern const style::color &botKbColor;
extern const style::color &sliderBgInactive;
extern const style::color &sliderBgActive;
extern const style::color &tooltipBg;
extern const style::color &tooltipFg;
extern const style::color &tooltipBorderFg;
extern const style::color &titleShadow;
extern const style::color &titleBg;
extern const style::color &titleBgActive;
extern const style::color &titleButtonBg;
extern const style::color &titleButtonFg;
extern const style::color &titleButtonBgOver;
extern const style::color &titleButtonFgOver;
extern const style::color &titleButtonBgActive;
extern const style::color &titleButtonFgActive;
extern const style::color &titleButtonBgActiveOver;
extern const style::color &titleButtonFgActiveOver;
extern const style::color &titleButtonCloseBg;
extern const style::color &titleButtonCloseFg;
extern const style::color &titleButtonCloseBgOver;
extern const style::color &titleButtonCloseFgOver;
extern const style::color &titleButtonCloseBgActive;
extern const style::color &titleButtonCloseFgActive;
extern const style::color &titleButtonCloseBgActiveOver;
extern const style::color &titleButtonCloseFgActiveOver;
extern const style::color &titleFg;
extern const style::color &titleFgActive;
extern const style::color &trayCounterBg;
extern const style::color &trayCounterBgMute;
extern const style::color &trayCounterFg;
extern const style::color &trayCounterBgMacInvert;
extern const style::color &trayCounterFgMacInvert;
extern const style::color &layerBg;
extern const style::color &cancelIconFg;
extern const style::color &cancelIconFgOver;
extern const style::color &boxBg;
extern const style::color &boxTextFg;
extern const style::color &boxTextFgGood;
extern const style::color &boxTextFgError;
extern const style::color &boxTitleFg;
extern const style::color &boxSearchBg;
extern const style::color &boxTitleAdditionalFg;
extern const style::color &boxTitleCloseFg;
extern const style::color &boxTitleCloseFgOver;
extern const style::color &membersAboutLimitFg;
extern const style::color &contactsBg;
extern const style::color &contactsBgOver;
extern const style::color &contactsNameFg;
extern const style::color &contactsStatusFg;
extern const style::color &contactsStatusFgOver;
extern const style::color &contactsStatusFgOnline;
extern const style::color &photoCropFadeBg;
extern const style::color &photoCropPointFg;
extern const style::color &callArrowFg;
extern const style::color &callArrowMissedFg;
extern const style::color &introBg;
extern const style::color &introTitleFg;
extern const style::color &introDescriptionFg;
extern const style::color &introErrorFg;
extern const style::color &introCoverTopBg;
extern const style::color &introCoverBottomBg;
extern const style::color &introCoverIconsFg;
extern const style::color &introCoverPlaneTrace;
extern const style::color &introCoverPlaneInner;
extern const style::color &introCoverPlaneOuter;
extern const style::color &introCoverPlaneTop;
extern const style::color &dialogsMenuIconFg;
extern const style::color &dialogsMenuIconFgOver;
extern const style::color &dialogsBg;
extern const style::color &dialogsNameFg;
extern const style::color &dialogsChatIconFg;
extern const style::color &dialogsDateFg;
extern const style::color &dialogsTextFg;
extern const style::color &dialogsTextFgService;
extern const style::color &dialogsDraftFg;
extern const style::color &dialogsVerifiedIconBg;
extern const style::color &dialogsVerifiedIconFg;
extern const style::color &dialogsSendingIconFg;
extern const style::color &dialogsSentIconFg;
extern const style::color &dialogsUnreadBg;
extern const style::color &dialogsUnreadBgMuted;
extern const style::color &dialogsUnreadFg;
extern const style::color &dialogsBgOver;
extern const style::color &dialogsNameFgOver;
extern const style::color &dialogsChatIconFgOver;
extern const style::color &dialogsDateFgOver;
extern const style::color &dialogsTextFgOver;
extern const style::color &dialogsTextFgServiceOver;
extern const style::color &dialogsDraftFgOver;
extern const style::color &dialogsVerifiedIconBgOver;
extern const style::color &dialogsVerifiedIconFgOver;
extern const style::color &dialogsSendingIconFgOver;
extern const style::color &dialogsSentIconFgOver;
extern const style::color &dialogsUnreadBgOver;
extern const style::color &dialogsUnreadBgMutedOver;
extern const style::color &dialogsUnreadFgOver;
extern const style::color &dialogsBgActive;
extern const style::color &dialogsNameFgActive;
extern const style::color &dialogsChatIconFgActive;
extern const style::color &dialogsDateFgActive;
extern const style::color &dialogsTextFgActive;
extern const style::color &dialogsTextFgServiceActive;
extern const style::color &dialogsDraftFgActive;
extern const style::color &dialogsVerifiedIconBgActive;
extern const style::color &dialogsVerifiedIconFgActive;
extern const style::color &dialogsSendingIconFgActive;
extern const style::color &dialogsSentIconFgActive;
extern const style::color &dialogsUnreadBgActive;
extern const style::color &dialogsUnreadBgMutedActive;
extern const style::color &dialogsUnreadFgActive;
extern const style::color &dialogsRippleBg;
extern const style::color &dialogsRippleBgActive;
extern const style::color &dialogsForwardBg;
extern const style::color &dialogsForwardFg;
extern const style::color &searchedBarBg;
extern const style::color &searchedBarFg;
extern const style::color &topBarBg;
extern const style::color &emojiPanBg;
extern const style::color &emojiPanCategories;
extern const style::color &emojiPanHeaderFg;
extern const style::color &emojiPanHeaderBg;
extern const style::color &emojiIconFg;
extern const style::color &emojiIconFgActive;
extern const style::color &stickerPanDeleteBg;
extern const style::color &stickerPanDeleteFg;
extern const style::color &stickerPreviewBg;
extern const style::color &historyTextInFg;
extern const style::color &historyTextInFgSelected;
extern const style::color &historyTextOutFg;
extern const style::color &historyTextOutFgSelected;
extern const style::color &historyLinkInFg;
extern const style::color &historyLinkInFgSelected;
extern const style::color &historyLinkOutFg;
extern const style::color &historyLinkOutFgSelected;
extern const style::color &historyFileNameInFg;
extern const style::color &historyFileNameInFgSelected;
extern const style::color &historyFileNameOutFg;
extern const style::color &historyFileNameOutFgSelected;
extern const style::color &historyOutIconFg;
extern const style::color &historyOutIconFgSelected;
extern const style::color &historyIconFgInverted;
extern const style::color &historySendingOutIconFg;
extern const style::color &historySendingInIconFg;
extern const style::color &historySendingInvertedIconFg;
extern const style::color &historyCallArrowInFg;
extern const style::color &historyCallArrowInFgSelected;
extern const style::color &historyCallArrowMissedInFg;
extern const style::color &historyCallArrowMissedInFgSelected;
extern const style::color &historyCallArrowOutFg;
extern const style::color &historyCallArrowOutFgSelected;
extern const style::color &historyUnreadBarBg;
extern const style::color &historyUnreadBarBorder;
extern const style::color &historyUnreadBarFg;
extern const style::color &historyForwardChooseBg;
extern const style::color &historyForwardChooseFg;
extern const style::color &historyPeer1NameFg;
extern const style::color &historyPeer1NameFgSelected;
extern const style::color &historyPeer1UserpicBg;
extern const style::color &historyPeer2NameFg;
extern const style::color &historyPeer2NameFgSelected;
extern const style::color &historyPeer2UserpicBg;
extern const style::color &historyPeer3NameFg;
extern const style::color &historyPeer3NameFgSelected;
extern const style::color &historyPeer3UserpicBg;
extern const style::color &historyPeer4NameFg;
extern const style::color &historyPeer4NameFgSelected;
extern const style::color &historyPeer4UserpicBg;
extern const style::color &historyPeer5NameFg;
extern const style::color &historyPeer5NameFgSelected;
extern const style::color &historyPeer5UserpicBg;
extern const style::color &historyPeer6NameFg;
extern const style::color &historyPeer6NameFgSelected;
extern const style::color &historyPeer6UserpicBg;
extern const style::color &historyPeer7NameFg;
extern const style::color &historyPeer7NameFgSelected;
extern const style::color &historyPeer7UserpicBg;
extern const style::color &historyPeer8NameFg;
extern const style::color &historyPeer8NameFgSelected;
extern const style::color &historyPeer8UserpicBg;
extern const style::color &historyPeerUserpicFg;
extern const style::color &historyPeerSavedMessagesBg;
extern const style::color &historyScrollBarBg;
extern const style::color &historyScrollBarBgOver;
extern const style::color &historyScrollBg;
extern const style::color &historyScrollBgOver;
extern const style::color &msgInBg;
extern const style::color &msgInBgSelected;
extern const style::color &msgOutBg;
extern const style::color &msgOutBgSelected;
extern const style::color &msgSelectOverlay;
extern const style::color &msgStickerOverlay;
extern const style::color &msgInServiceFg;
extern const style::color &msgInServiceFgSelected;
extern const style::color &msgOutServiceFg;
extern const style::color &msgOutServiceFgSelected;
extern const style::color &msgInShadow;
extern const style::color &msgInShadowSelected;
extern const style::color &msgOutShadow;
extern const style::color &msgOutShadowSelected;
extern const style::color &msgInDateFg;
extern const style::color &msgInDateFgSelected;
extern const style::color &msgOutDateFg;
extern const style::color &msgOutDateFgSelected;
extern const style::color &msgServiceFg;
extern const style::color &msgServiceBg;
extern const style::color &msgServiceBgSelected;
extern const style::color &msgInReplyBarColor;
extern const style::color &msgInReplyBarSelColor;
extern const style::color &msgOutReplyBarColor;
extern const style::color &msgOutReplyBarSelColor;
extern const style::color &msgImgReplyBarColor;
extern const style::color &msgInMonoFg;
extern const style::color &msgOutMonoFg;
extern const style::color &msgInMonoFgSelected;
extern const style::color &msgOutMonoFgSelected;
extern const style::color &msgDateImgFg;
extern const style::color &msgDateImgBg;
extern const style::color &msgDateImgBgOver;
extern const style::color &msgDateImgBgSelected;
extern const style::color &msgFileThumbLinkInFg;
extern const style::color &msgFileThumbLinkInFgSelected;
extern const style::color &msgFileThumbLinkOutFg;
extern const style::color &msgFileThumbLinkOutFgSelected;
extern const style::color &msgFileInBg;
extern const style::color &msgFileInBgOver;
extern const style::color &msgFileInBgSelected;
extern const style::color &msgFileOutBg;
extern const style::color &msgFileOutBgOver;
extern const style::color &msgFileOutBgSelected;
extern const style::color &msgFile1Bg;
extern const style::color &msgFile1BgDark;
extern const style::color &msgFile1BgOver;
extern const style::color &msgFile1BgSelected;
extern const style::color &msgFile2Bg;
extern const style::color &msgFile2BgDark;
extern const style::color &msgFile2BgOver;
extern const style::color &msgFile2BgSelected;
extern const style::color &msgFile3Bg;
extern const style::color &msgFile3BgDark;
extern const style::color &msgFile3BgOver;
extern const style::color &msgFile3BgSelected;
extern const style::color &msgFile4Bg;
extern const style::color &msgFile4BgDark;
extern const style::color &msgFile4BgOver;
extern const style::color &msgFile4BgSelected;
extern const style::color &historyFileInIconFg;
extern const style::color &historyFileInIconFgSelected;
extern const style::color &historyFileInRadialFg;
extern const style::color &historyFileInRadialFgSelected;
extern const style::color &historyFileOutIconFg;
extern const style::color &historyFileOutIconFgSelected;
extern const style::color &historyFileOutRadialFg;
extern const style::color &historyFileOutRadialFgSelected;
extern const style::color &historyFileThumbIconFg;
extern const style::color &historyFileThumbIconFgSelected;
extern const style::color &historyFileThumbRadialFg;
extern const style::color &historyFileThumbRadialFgSelected;
extern const style::color &historyVideoMessageProgressFg;
extern const style::color &msgWaveformInActive;
extern const style::color &msgWaveformInActiveSelected;
extern const style::color &msgWaveformInInactive;
extern const style::color &msgWaveformInInactiveSelected;
extern const style::color &msgWaveformOutActive;
extern const style::color &msgWaveformOutActiveSelected;
extern const style::color &msgWaveformOutInactive;
extern const style::color &msgWaveformOutInactiveSelected;
extern const style::color &msgBotKbOverBgAdd;
extern const style::color &msgBotKbIconFg;
extern const style::color &msgBotKbRippleBg;
extern const style::color &mediaInFg;
extern const style::color &mediaInFgSelected;
extern const style::color &mediaOutFg;
extern const style::color &mediaOutFgSelected;
extern const style::color &youtubePlayIconBg;
extern const style::color &youtubePlayIconFg;
extern const style::color &videoPlayIconBg;
extern const style::color &videoPlayIconFg;
extern const style::color &toastBg;
extern const style::color &toastFg;
extern const style::color &reportSpamBg;
extern const style::color &reportSpamFg;
extern const style::color &historyToDownBg;
extern const style::color &historyToDownBgOver;
extern const style::color &historyToDownBgRipple;
extern const style::color &historyToDownFg;
extern const style::color &historyToDownFgOver;
extern const style::color &historyToDownShadow;
extern const style::color &historyComposeAreaBg;
extern const style::color &historyComposeAreaFg;
extern const style::color &historyComposeAreaFgService;
extern const style::color &historyComposeIconFg;
extern const style::color &historyComposeIconFgOver;
extern const style::color &historySendIconFg;
extern const style::color &historySendIconFgOver;
extern const style::color &historyPinnedBg;
extern const style::color &historyReplyBg;
extern const style::color &historyReplyIconFg;
extern const style::color &historyReplyCancelFg;
extern const style::color &historyReplyCancelFgOver;
extern const style::color &historyComposeButtonBg;
extern const style::color &historyComposeButtonBgOver;
extern const style::color &historyComposeButtonBgRipple;
extern const style::color &mapPointDrop;
extern const style::color &mapPointDot;
extern const style::color &overviewCheckBg;
extern const style::color &overviewCheckBgActive;
extern const style::color &overviewCheckBorder;
extern const style::color &overviewCheckFg;
extern const style::color &overviewCheckFgActive;
extern const style::color &overviewPhotoSelectOverlay;
extern const style::color &profileStatusFgOver;
extern const style::color &profileVerifiedCheckBg;
extern const style::color &profileVerifiedCheckFg;
extern const style::color &profileAdminStartFg;
extern const style::color &profileAdminStarFgOver;
extern const style::color &profileOtherAdminStarFg;
extern const style::color &profileOtherAdminStarFgOver;
extern const style::color &notificationsBoxMonitorFg;
extern const style::color &notificationsBoxScreenBg;
extern const style::color &notificationSampleUserpicFg;
extern const style::color &notificationSampleCloseFg;
extern const style::color &notificationSampleTextFg;
extern const style::color &notificationSampleNameFg;
extern const style::color &changePhoneSimcardFrom;
extern const style::color &changePhoneSimcardTo;
extern const style::color &mainMenuBg;
extern const style::color &mainMenuCoverBg;
extern const style::color &mainMenuCoverFg;
extern const style::color &mainMenuCloudFg;
extern const style::color &mainMenuCloudBg;
extern const style::color &mediaPlayerBg;
extern const style::color &mediaPlayerActiveFg;
extern const style::color &mediaPlayerInactiveFg;
extern const style::color &mediaPlayerDisabledFg;
extern const style::color &mediaviewFileBg;
extern const style::color &mediaviewFileNameFg;
extern const style::color &mediaviewFileSizeFg;
extern const style::color &mediaviewFileRedCornerFg;
extern const style::color &mediaviewFileYellowCornerFg;
extern const style::color &mediaviewFileGreenCornerFg;
extern const style::color &mediaviewFileBlueCornerFg;
extern const style::color &mediaviewFileExtFg;
extern const style::color &mediaviewMenuBg;
extern const style::color &mediaviewMenuBgOver;
extern const style::color &mediaviewMenuBgRipple;
extern const style::color &mediaviewMenuFg;
extern const style::color &mediaviewBg;
extern const style::color &mediaviewVideoBg;
extern const style::color &mediaviewControlBg;
extern const style::color &mediaviewControlFg;
extern const style::color &mediaviewCaptionBg;
extern const style::color &mediaviewCaptionFg;
extern const style::color &mediaviewTextLinkFg;
extern const style::color &mediaviewSaveMsgBg;
extern const style::color &mediaviewSaveMsgFg;
extern const style::color &mediaviewPlaybackActive;
extern const style::color &mediaviewPlaybackInactive;
extern const style::color &mediaviewPlaybackActiveOver;
extern const style::color &mediaviewPlaybackInactiveOver;
extern const style::color &mediaviewPlaybackProgressFg;
extern const style::color &mediaviewPlaybackIconFg;
extern const style::color &mediaviewPlaybackIconFgOver;
extern const style::color &mediaviewTransparentBg;
extern const style::color &mediaviewTransparentFg;
extern const style::color &notificationBg;
extern const style::color &callBg;
extern const style::color &callNameFg;
extern const style::color &callFingerprintBg;
extern const style::color &callStatusFg;
extern const style::color &callIconFg;
extern const style::color &callAnswerBg;
extern const style::color &callAnswerRipple;
extern const style::color &callAnswerBgOuter;
extern const style::color &callHangupBg;
extern const style::color &callHangupRipple;
extern const style::color &callCancelBg;
extern const style::color &callCancelFg;
extern const style::color &callCancelRipple;
extern const style::color &callMuteRipple;
extern const style::color &callBarBg;
extern const style::color &callBarMuteRipple;
extern const style::color &callBarBgMuted;
extern const style::color &callBarUnmuteRipple;
extern const style::color &callBarFg;
extern const style::color &importantTooltipBg;
extern const style::color &importantTooltipFg;
extern const style::color &importantTooltipFgLink;
} // namespace st
