/*
WARNING! All changes made in this file will be lost!
Created from 'widgets.style' by 'codegen_style'

This file is part of Telegram Desktop,
the official desktop application for the Telegram messaging service.

For license and copyright information please follow this link:
https://github.com/telegramdesktop/tdesktop/blob/master/LEGAL
*/
#pragma once

#include "ui/style/style_core.h"

namespace style {
namespace internal {

void init_style_widgets();

} // namespace internal

struct LabelSimple {
	style::font font;
	int maxWidth;
	style::color textFg;
};

struct FlatLabel {
	style::margins margin;
	int minWidth;
	style::align align;
	style::color textFg;
	int maxHeight;
	style::TextStyle style;
	style::TextPalette palette;
};

struct LinkButton {
	style::color color;
	style::color overColor;
	style::font font;
	style::font overFont;
	style::margins padding;
};

struct RippleAnimation {
	style::color color;
	int showDuration;
	int hideDuration;
};

struct InfiniteRadialAnimation {
	style::color color;
	int thickness;
	style::size size;
	int linearPeriod;
	int sinePeriod;
	int sineDuration;
	int sineShift;
	double arcMin;
	double arcMax;
};

struct FlatButton {
	style::color color;
	style::color overColor;
	style::color bgColor;
	style::color overBgColor;
	int width;
	int height;
	int textTop;
	style::font font;
	style::font overFont;
	style::RippleAnimation ripple;
};

struct RoundButton {
	style::color textFg;
	style::color textFgOver;
	style::color textBg;
	style::color textBgOver;
	style::color numbersTextFg;
	style::color numbersTextFgOver;
	int numbersSkip;
	int width;
	int height;
	style::margins padding;
	int textTop;
	style::icon icon;
	style::point iconPosition;
	style::font font;
	style::RippleAnimation ripple;
};

struct Toggle {
	style::color toggledBg;
	style::color toggledFg;
	style::color untoggledBg;
	style::color untoggledFg;
	int duration;
	int border;
	int shift;
	int diameter;
	int width;
	int xsize;
	int vsize;
	int vshift;
	int stroke;
	style::icon lockIcon;
	int rippleAreaPadding;
};

struct Check {
	style::color bg;
	style::color untoggledFg;
	style::color toggledFg;
	int diameter;
	int thickness;
	style::icon icon;
	int duration;
	int rippleAreaPadding;
};

struct Radio {
	style::color bg;
	style::color untoggledFg;
	style::color toggledFg;
	int diameter;
	int thickness;
	int skip;
	int duration;
	int rippleAreaPadding;
};

struct Checkbox {
	style::color textFg;
	style::color textFgActive;
	int width;
	style::margins margin;
	style::point textPosition;
	style::point checkPosition;
	style::TextStyle style;
	style::point rippleAreaPosition;
	style::color rippleBg;
	style::color rippleBgActive;
	style::RippleAnimation ripple;
	double disabledOpacity;
};

struct ScrollArea {
	style::color bg;
	style::color bgOver;
	style::color barBg;
	style::color barBgOver;
	int round;
	int width;
	int minHeight;
	int deltax;
	int deltat;
	int deltab;
	int topsh;
	int bottomsh;
	style::color shColor;
	int duration;
	int hiding;
};

struct FlatInput {
	style::color textColor;
	style::color bgColor;
	style::color bgActive;
	int width;
	int height;
	style::margins textMrg;
	style::align align;
	style::font font;
	style::icon icon;
	int borderWidth;
	style::color borderColor;
	style::color borderActive;
	style::color phColor;
	style::color phFocusColor;
	style::point phPos;
	style::align phAlign;
	int phShift;
	int phDuration;
};

struct InputField {
	style::color textBg;
	style::color textFg;
	style::margins textMargins;
	style::align textAlign;
	style::color placeholderFg;
	style::color placeholderFgActive;
	style::color placeholderFgError;
	style::margins placeholderMargins;
	style::align placeholderAlign;
	double placeholderScale;
	int placeholderShift;
	style::font placeholderFont;
	int duration;
	style::color borderFg;
	style::color borderFgActive;
	style::color borderFgError;
	int border;
	int borderActive;
	style::font font;
	int width;
	int heightMin;
	int heightMax;
};

struct OutlineButton {
	int outlineWidth;
	style::color outlineFg;
	style::color outlineFgOver;
	style::color textBg;
	style::color textBgOver;
	style::color textFg;
	style::color textFgOver;
	style::font font;
	style::margins padding;
	style::RippleAnimation ripple;
};

struct IconButton {
	int width;
	int height;
	style::icon icon;
	style::icon iconOver;
	style::point iconPosition;
	int duration;
	style::point rippleAreaPosition;
	int rippleAreaSize;
	style::RippleAnimation ripple;
};

struct Shadow {
	style::icon left;
	style::icon topLeft;
	style::icon top;
	style::icon topRight;
	style::icon right;
	style::icon bottomRight;
	style::icon bottom;
	style::icon bottomLeft;
	style::margins extend;
	style::color fallback;
};

struct MediaSlider {
	int width;
	style::color activeFg;
	style::color inactiveFg;
	style::color activeFgOver;
	style::color inactiveFgOver;
	style::color activeFgDisabled;
	style::color inactiveFgDisabled;
	style::color receivedTillFg;
	style::size seekSize;
	int duration;
};

struct FilledSlider {
	int fullWidth;
	int lineWidth;
	style::color activeFg;
	style::color inactiveFg;
	style::color disabledFg;
	int duration;
};

struct RoundCheckbox {
	style::color border;
	style::color bgInactive;
	style::color bgActive;
	int width;
	int size;
	double sizeSmall;
	int duration;
	double bgDuration;
	double fgDuration;
	style::icon check;
};

struct RoundImageCheckbox {
	int imageRadius;
	int imageSmallRadius;
	int selectWidth;
	style::color selectFg;
	int selectDuration;
	style::RoundCheckbox check;
};

struct CrossAnimation {
	style::color fg;
	int size;
	int skip;
	int stroke;
	double minScale;
};

struct CrossButton {
	int width;
	int height;
	style::CrossAnimation cross;
	style::color crossFg;
	style::color crossFgOver;
	style::point crossPosition;
	int duration;
	int loadingPeriod;
	style::RippleAnimation ripple;
};

struct MultiSelectItem {
	style::margins padding;
	int maxWidth;
	int height;
	style::TextStyle style;
	style::color textBg;
	style::color textFg;
	style::color textActiveBg;
	style::color textActiveFg;
	int duration;
	style::color deleteFg;
	style::CrossAnimation deleteCross;
	double minScale;
};

struct MultiSelect {
	style::color bg;
	style::margins padding;
	int maxHeight;
	style::ScrollArea scroll;
	style::MultiSelectItem item;
	int itemSkip;
	style::InputField field;
	int fieldMinWidth;
	style::icon fieldIcon;
	int fieldIconSkip;
	style::CrossButton fieldCancel;
	int fieldCancelSkip;
};

struct CallButton {
	style::IconButton button;
	style::color bg;
	double angle;
	int outerRadius;
	style::color outerBg;
};

struct Menu {
	int skip;
	style::color itemBg;
	style::color itemBgOver;
	style::color itemFg;
	style::color itemFgOver;
	style::color itemFgDisabled;
	style::color itemFgShortcut;
	style::color itemFgShortcutOver;
	style::color itemFgShortcutDisabled;
	style::margins itemPadding;
	style::point itemIconPosition;
	style::font itemFont;
	style::Toggle itemToggle;
	style::Toggle itemToggleOver;
	int itemToggleShift;
	style::margins separatorPadding;
	int separatorWidth;
	style::color separatorFg;
	style::icon arrow;
	int widthMin;
	int widthMax;
	style::RippleAnimation ripple;
};

struct PanelAnimation {
	double startWidth;
	double widthDuration;
	double startHeight;
	double heightDuration;
	double startOpacity;
	double opacityDuration;
	double startFadeTop;
	double fadeHeight;
	double fadeOpacity;
	style::color fadeBg;
	style::Shadow shadow;
};

struct PopupMenu {
	style::Shadow shadow;
	style::margins scrollPadding;
	style::PanelAnimation animation;
	style::Menu menu;
	int duration;
	int showDuration;
};

struct InnerDropdown {
	style::margins padding;
	style::Shadow shadow;
	style::PanelAnimation animation;
	int duration;
	int showDuration;
	int width;
	style::color bg;
	style::ScrollArea scroll;
	style::margins scrollMargin;
	style::margins scrollPadding;
};

struct DropdownMenu {
	style::InnerDropdown wrap;
	style::Menu menu;
};

struct Tooltip {
	style::color textBg;
	style::color textFg;
	style::TextStyle textStyle;
	style::color textBorder;
	style::margins textPadding;
	style::point shift;
	int skip;
	int widthMax;
	int linesMax;
};

struct ImportantTooltip {
	style::color bg;
	style::margins margin;
	style::margins padding;
	int radius;
	int arrow;
	int arrowSkipMin;
	int arrowSkip;
	int shift;
	int duration;
};

struct UserpicButton {
	style::size size;
	int photoSize;
	style::point photoPosition;
	style::RoundButton changeButton;
	style::icon changeIcon;
	style::point changeIconPosition;
	int duration;
	int uploadHeight;
	style::color uploadBg;
	style::icon uploadIcon;
	style::point uploadIconPosition;
};

struct FeedUserpicButton {
	style::size size;
	int innerSize;
	style::point innerPosition;
	style::UserpicButton innerPart;
};

struct InfoProfileButton {
	style::color textFg;
	style::color textFgOver;
	style::color textBg;
	style::color textBgOver;
	style::font font;
	int height;
	style::margins padding;
	style::Toggle toggle;
	style::Toggle toggleOver;
	int toggleSkip;
	style::RippleAnimation ripple;
};

struct InfoProfileCountButton {
	style::InfoProfileButton button;
	style::icon icon;
	style::point iconPosition;
	style::FlatLabel label;
	style::point labelPosition;
};

struct PassportScanRow {
	style::margins padding;
	int size;
	int textLeft;
	int nameTop;
	int statusTop;
	int border;
	style::color borderFg;
	style::IconButton remove;
	style::RoundButton restore;
};

struct SettingsSlider {
	int height;
	int barTop;
	int barSkip;
	int barStroke;
	style::color barFg;
	style::color barFgActive;
	int labelTop;
	style::font labelFont;
	style::color labelFg;
	style::color labelFgActive;
	int duration;
	int rippleBottomSkip;
	style::color rippleBg;
	style::color rippleBgActive;
	style::RippleAnimation ripple;
};

struct BotKeyboardButton {
	int margin;
	int padding;
	int height;
	int textTop;
	style::RippleAnimation ripple;
};

struct TwoIconButton {
	int width;
	int height;
	style::icon iconBelow;
	style::icon iconAbove;
	style::icon iconBelowOver;
	style::icon iconAboveOver;
	style::point iconPosition;
	style::point rippleAreaPosition;
	int rippleAreaSize;
	style::RippleAnimation ripple;
};

struct MediaPlayerButton {
	style::point playPosition;
	style::size playOuter;
	style::point pausePosition;
	style::size pauseOuter;
	int pauseStroke;
	style::point cancelPosition;
	style::size cancelOuter;
	int cancelStroke;
	style::point rippleAreaPosition;
	int rippleAreaSize;
	style::RippleAnimation ripple;
};

struct PeerListItem {
	int left;
	int bottom;
	int height;
	style::point photoPosition;
	style::point namePosition;
	style::TextStyle nameStyle;
	style::point statusPosition;
	int photoSize;
	int maximalWidth;
	style::OutlineButton button;
	style::color statusFg;
	style::color statusFgOver;
	style::color statusFgActive;
};

struct PeerList {
	style::margins padding;
	style::PeerListItem item;
};

struct SearchFieldRow {
	int height;
	style::margins padding;
	style::InputField field;
	style::icon fieldIcon;
	int fieldIconSkip;
	style::CrossButton fieldCancel;
	int fieldCancelSkip;
};

struct InfoTopBar {
	int height;
	style::IconButton back;
	style::FlatLabel title;
	style::point titlePosition;
	style::color bg;
	style::IconButton mediaCancel;
	int mediaActionsSkip;
	style::IconButton mediaForward;
	style::IconButton mediaDelete;
	style::IconButton search;
	style::SearchFieldRow searchRow;
	style::color highlightBg;
	int highlightDuration;
};

struct LevelMeter {
	int height;
	int lineWidth;
	int lineSpacing;
	int lineCount;
	style::color activeFg;
	style::color inactiveFg;
};

} // namespace style

namespace st {
extern const style::InfiniteRadialAnimation &defaultInfiniteRadialAnimation;
extern const style::LabelSimple &defaultLabelSimple;
extern const style::FlatLabel &defaultFlatLabel;
extern const style::LinkButton &defaultLinkButton;
extern const style::RippleAnimation &defaultRippleAnimation;
extern const style::RippleAnimation &emptyRippleAnimation;
extern const style::RoundButton &defaultActiveButton;
extern const style::RoundButton &defaultLightButton;
extern const style::ScrollArea &defaultScrollArea;
extern const style::ScrollArea &defaultSolidScroll;
extern const style::font &defaultInputFont;
extern const style::FlatInput &defaultFlatInput;
extern const style::OutlineButton &defaultLeftOutlineButton;
extern const style::OutlineButton &attentionLeftOutlineButton;
extern const style::InputField &defaultInputField;
extern const style::icon &defaultCheckboxIcon;
extern const style::Check &defaultCheck;
extern const style::Radio &defaultRadio;
extern const style::Toggle &defaultToggle;
extern const style::Checkbox &defaultCheckbox;
extern const style::IconButton &defaultIconButton;
extern const style::MultiSelectItem &defaultMultiSelectItem;
extern const int &widgetSlideDuration;
extern const int &widgetFadeDuration;
extern const style::icon &fieldSearchIcon;
extern const style::icon &boxFieldSearchIcon;
extern const style::SettingsSlider &defaultSettingsSlider;
extern const style::SettingsSlider &defaultTabsSlider;
extern const style::Shadow &defaultRoundShadow;
extern const style::Shadow &defaultEmptyShadow;
extern const style::PanelAnimation &defaultPanelAnimation;
extern const style::MediaSlider &defaultContinuousSlider;
extern const style::RoundCheckbox &defaultRoundCheckbox;
extern const style::icon &defaultMenuArrow;
extern const style::Toggle &defaultMenuToggle;
extern const style::Toggle &defaultMenuToggleOver;
extern const style::Menu &defaultMenu;
extern const style::PopupMenu &defaultPopupMenu;
extern const style::InnerDropdown &defaultInnerDropdown;
extern const style::DropdownMenu &defaultDropdownMenu;
extern const style::Tooltip &defaultTooltip;
extern const style::ImportantTooltip &defaultImportantTooltip;
extern const style::FlatLabel &defaultImportantTooltipLabel;
extern const style::icon &defaultChangeUserpicIcon;
extern const style::icon &defaultUploadUserpicIcon;
extern const style::UserpicButton &defaultUserpicButton;
extern const style::FeedUserpicButton &defaultFeedUserpicButton;
extern const style::icon &historyToDownBelow;
extern const style::icon &historyToDownBelowOver;
extern const style::icon &contactsAddIconBelow;
extern const style::icon &contactsAddIconBelowOver;
extern const int &historySendActionTypingDuration;
extern const int &historySendActionTypingHalfPeriod;
extern const int &historySendActionTypingDeltaTime;
extern const style::point &historySendActionTypingPosition;
extern const int &historySendActionTypingDelta;
extern const int &historySendActionTypingLargeNumerator;
extern const int &historySendActionTypingSmallNumerator;
extern const double &historySendActionTypingDenominator;
extern const int &historySendActionRecordDuration;
extern const style::point &historySendActionRecordPosition;
extern const int &historySendActionRecordDelta;
extern const int &historySendActionRecordStrokeNumerator;
extern const double &historySendActionRecordDenominator;
extern const int &historySendActionUploadDuration;
extern const style::point &historySendActionUploadPosition;
extern const int &historySendActionUploadDelta;
extern const int &historySendActionUploadStrokeNumerator;
extern const int &historySendActionUploadSizeNumerator;
extern const double &historySendActionUploadDenominator;
extern const style::OutlineButton &defaultPeerListButton;
extern const style::PeerListItem &defaultPeerListItem;
extern const style::PeerList &defaultPeerList;
extern const style::LevelMeter &defaultLevelMeter;
} // namespace st
